<?php
/**
 * Copyright since 2007 PrestaShop SA and Contributors
 * PrestaShop is an International Registered Trademark & Property of PrestaShop SA
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.md.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/OSL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to https://devdocs.prestashop.com/ for more information.
 *
 * @author Ship-Quik SL <info@ship-quik.com>
 * @copyright Since 2022 Ship-Quik SL
 * @license   https://opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 */

use ShipQuik\PrestaShop\ShipQuik_BD;

class Ship_QuikDisplayCarrierExtraContentController
{
    protected $module;
    protected $file;
    protected $_path;

    protected $context;

    public function __construct($module, $file, $path)
    {
        $this->file = $file;
        $this->module = $module;
        $this->context = Context::getContext();
        $this->_path = $path;
    }

    public function run($params)
    {
        $result = ShipQuik_BD::getDatabyCart($this->context->cart, $params['carrier']['id']);

        $changeDUA = $this->module->config->getValueByKey('chargeDUA');
        $DUACost = ($changeDUA ? $result['dua'] : 0);

        $DUAText = ($changeDUA  && $DUACost > 0 ? $this->module->l('Costes de exportación incluidos') : '');

        if ($result) {
            $logo = Tools::file_get_contents(SHIP_QUIK_PLUGIN_PATH . 'views/img/logos/' . $result['supplier'] . '.base64');

            $this->context->smarty->assign('ship_quik_dua_text', $DUAText);

            $this->context->smarty->assign('ship_quik_shipment_data', $result);
            $this->context->smarty->assign('ship_quik_logo', $logo);
        }

        return $this->module->display($this->file, 'displayCarrierExtraContent.tpl');
    }
}
