/**
 * Copyright since 2007 PrestaShop SA and Contributors
 * PrestaShop is an International Registered Trademark & Property of PrestaShop SA
 *
 * NOTICE OF LICENSE
 *
 * This source file is subject to the Open Software License (OSL 3.0)
 * that is bundled with this package in the file LICENSE.md.
 * It is also available through the world-wide-web at this URL:
 * https://opensource.org/licenses/OSL-3.0
 * If you did not receive a copy of the license and are unable to
 * obtain it through the world-wide-web, please send an email
 * to license@prestashop.com so we can send you a copy immediately.
 *
 * DISCLAIMER
 *
 * Do not edit or add to this file if you wish to upgrade PrestaShop to newer
 * versions in the future. If you wish to customize PrestaShop for your
 * needs please refer to https://devdocs.prestashop.com/ for more information.
 *
 * @author Ship-Quik SL <info@ship-quik.com>
 * @copyright Since 2022 Ship-Quik SL
 * @license   https://opensource.org/licenses/OSL-3.0 Open Software License (OSL 3.0)
 */
 document.addEventListener('DOMContentLoaded', function () {

    jQuery('button[name="submitship_quik_activation"]').parent().parent().addClass('panel-activation');
    jQuery('.info-activation').parent().removeClass('col-lg-8').addClass('col-lg-12');
    jQuery('.info-activation').parent().parent().parent().parent().addClass('panel-activation');

    jQuery(document).on('submit', 'form',
        function () {
            var result = true;

            // Evaluating no rows empty
            jQuery('#shippingTableRates .rate-row').each(function (index) {
                jQuery(jQuery(this).find('.field')).each(function (index) {
                    if (jQuery(this).val().trim() == '' || jQuery(this).val().trim() == '0') {
                        jQuery(this).focus();

                        result = false;
                    }
                });
            });

            jQuery('#shippingPackageList .rate-row').each(function (index) {
                jQuery(jQuery(this).find('.field')).each(function (index) {
                    if (jQuery(this).val().trim() == '' || jQuery(this).val().trim() == '0') {
                        jQuery(this).focus();

                        result = false;
                    }
                });
            });

            if (result == false) return result;

            // Evaluating a rows, first field always hight than second
            jQuery('#shippingTableRates .rate-row').each(function (index) {
                var first = parseFloat(jQuery(this).find('.field').eq(0).val());
                var last = parseFloat(jQuery(this).find('.field').eq(1).val());

                if (first >= last) {
                    alert('Error en tabla de rangos: Rango erroneo en fila ' + index);
                    jQuery(this).find('.field').eq(0).focus();

                    result =  false;
                }

                return;
            });

            if (result == false) return result;

            // Evaluating row agaist row, , first field always hight than last field previous row
            var sw = true;
            jQuery('#shippingTableRates .rate-row').each(function (index) {
                if (sw == true) {
                    var first = parseFloat(jQuery(this).find('.field').eq(1).val());
                    sw = false;
                } else {
                    var last = parseFloat(jQuery(this).find('.field').eq(0).val());

                    if (last <= first) {
                        alert('Error en tabla de rangos: Rango erroneo en fila ' + index);
                        jQuery(this).find('.field').eq(0).focus();

                        result =  false;
                    }
                    first = parseFloat(jQuery(this).find('.field').eq(1).val());
                }

                return;
            });

            return result;
        }
    );
});
